

################################################################
# proc challResp {pattern response info}--
#    Hold a single interchange challenge/response conversation.
# Arguments
#   pattern:	the pattern to wait for as a challenge
#   response:   The response to this pattern.
#   info:       Identifying information about this interaction
#               for use with exception reporting.
# 
# Results
#   
# 
proc challResp {pattern response info} {
  expect {
    $pattern {exp_send "$response\n"}
    timeout  {error "Timeout at $info" "Timeout at $info"}
    eof      {error "Eof at $info" "Eof at $info"}
  }
}

################################################################
# proc watchFile {host passwd fileName pattern}--
#    Watch a file on a remote system for a given pattern
# Arguments
#   host:	IP Address of the host on which the file resides.
#   passwd:	Password for accessing the host
#   fileName:	Full path to the file to be watched
#   pattern:	A pattern to watch for in the file.
# Results
#   Throws an error if the expected pattern is not seen.
# 
proc watchFile {host passwd fileName pattern} {
  global spawn_id

  set stty_init -echo
  spawn ssh -l root 127.0.0.1

  challResp "word:" $passwd "password prompt"
  challResp "%>" "cd /var/log" "first shell prompt"
  challResp "%>" "tail -f messages" "second shell prompt"

  expect {
    "$pattern" {puts "ROOT LOGIN SUCCESSFUL"}
    timeout {error "timeout" "Timeout waiting for \"$pattern\""}
    eof     {error "eof" "Eof waiting for \"$pattern\""}
  }  
}

watchFile 127.0.0.1 PASSWORD /var/log/messages "ted password for ROOT"
